SystemOrganization addCategory: #ConfigurationOfGarageGlorp!

Object subclass: #ConfigurationOfGarageGlorp
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGarageGlorp'!

!ConfigurationOfGarageGlorp class methodsFor: 'development support' stamp: 'GuillermoPolito 5/13/2015 01:14'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfGarageGlorp class methodsFor: 'private' stamp: 'GuillermoPolito 5/13/2015 01:14'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfGarageGlorp class methodsFor: 'private' stamp: 'GuillermoPolito 5/13/2015 01:14'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfGarageGlorp class methodsFor: 'private' stamp: 'GuillermoPolito 5/13/2015 01:14'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfGarageGlorp class methodsFor: 'metacello tool support' stamp: 'GuillermoPolito 5/13/2015 01:14'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGarageGlorp class methodsFor: 'loading' stamp: 'GuillermoPolito 5/13/2015 01:14'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfGarageGlorp class methodsFor: 'loading' stamp: 'GuillermoPolito 5/13/2015 01:14'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfGarageGlorp class methodsFor: 'loading' stamp: 'GuillermoPolito 5/13/2015 01:14'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfGarageGlorp class methodsFor: 'accessing' stamp: 'GuillermoPolito 5/13/2015 01:14'!
project

	^self new project! !

!ConfigurationOfGarageGlorp class methodsFor: 'development support' stamp: 'GuillermoPolito 5/13/2015 01:14'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfGarageGlorp methodsFor: 'baselines' stamp: 'GuillermoPolito 5/13/2015 02:01'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/DBXTalk/Glorp/main/'.
		spec 
			project: 'Glorp' with: [
				spec
					className: #ConfigurationOfGlorp;
					versionString: #'bleedingEdge';
					repository: 'http://smalltalkhub.com/mc/DBXTalk/Glorp/main/' ];
			project: 'Garage' with: [
				spec
					className: #ConfigurationOfGarage;
					versionString: #'development';
					loads: #('Garage' );
					repository: 'http://smalltalkhub.com/mc/DBXTalk/Garage/main/' ].
		spec package: #GarageGlorpDriver with: [
				spec requires: #('Glorp' 'Garage' ). ]. ].
! !

!ConfigurationOfGarageGlorp methodsFor: 'accessing' stamp: 'GuillermoPolito 5/13/2015 01:14'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfGarageGlorp methodsFor: 'symbolic versions' stamp: 'GuillermoPolito 5/13/2015 01:14'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfGarageGlorp methodsFor: 'accessing' stamp: 'GuillermoPolito 5/13/2015 01:14'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !
